// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BOPAlgo_CheckerSI_HeaderFile
#define _BOPAlgo_CheckerSI_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineAlloc_HeaderFile
#include <Standard_DefineAlloc.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _BOPCol_DataMapOfShapeShape_HeaderFile
#include <BOPCol_DataMapOfShapeShape.hxx>
#endif
#ifndef _BOPAlgo_PaveFiller_HeaderFile
#include <BOPAlgo_PaveFiller.hxx>
#endif


//! Checks shape on self-interference. <br>
class BOPAlgo_CheckerSI  : public BOPAlgo_PaveFiller {
public:

  DEFINE_STANDARD_ALLOC

  
  Standard_EXPORT   BOPAlgo_CheckerSI();
Standard_EXPORT virtual ~BOPAlgo_CheckerSI();
  
  Standard_EXPORT   virtual  void Perform() ;
  //!  Sets the level of checking shape on self-interference. <br>
//!           It defines which interferferences will be checked: <br>
//!           0 - only V/V; <br>
//!           1 - V/V and V/E; <br>
//!           2 - V/V, V/E and E/E; <br>
//!           3 - V/V, V/E, E/E and V/F; <br>
//!           4 - V/V, V/E, E/E, V/F and E/F; <br>
//!           5 - all interferences, default value. <br>
  Standard_EXPORT     void SetLevelOfCheck(const Standard_Integer theLevel) ;
  //! Sets the flag <theFlag> that defines <br>
//!  the mode of the treatment: <br>
//!  the copy of the argument when theFlag is true <br>
//!  the argument itself  when theFlag is false <br>
  Standard_EXPORT     void SetNonDestructive(const Standard_Boolean theFlag) ;
  //! Returns the flag that defines the <br>
//!  mode of the treatment: <br>
//!  true when the copy of the argument is used <br>
//!  false when the argument itself  is used <br>
  Standard_EXPORT     Standard_Boolean NonDestructive() const;





protected:

  
  Standard_EXPORT   virtual  void Init() ;
  //! Provides post-treatment actions <br>
  Standard_EXPORT     void PostTreat() ;
  
  Standard_EXPORT   virtual  void PerformVZ() ;
  
  Standard_EXPORT   virtual  void PerformEZ() ;
  
  Standard_EXPORT   virtual  void PerformFZ() ;
  
  Standard_EXPORT   virtual  void PerformZZ() ;
  
  Standard_EXPORT   virtual  void PrepareCopy() ;
  //! Provides post-treatment actions for the copy <br>
  Standard_EXPORT     void PostTreatCopy() ;


Standard_Integer myLevelOfCheck;
Standard_Boolean myNonDestructive;
BOPCol_DataMapOfShapeShape myNewOldMap;


private:





};





// other Inline functions and methods (like "C++: function call" methods)


#endif
